'use strict';

import warning from './routerWarning';

// No-op by default.
var deprecateObjectProperties = function deprecateObjectProperties(object) {
  return object;
};

if (process.env.NODE_ENV !== 'production') {
  if (typeof Proxy === 'function') {
    deprecateObjectProperties = function (object, message) {
      return new Proxy(object, {
        get: function get(target, name) {
          // Only warn for own properties to avoid false positives.
          if (Object.prototype.hasOwnProperty.call(target, name)) {
            process.env.NODE_ENV !== 'production' ? warning(false, message) : undefined;
          }

          return target[name];
        },

        ownKeys: function ownKeys() {
          return [];
        }
      });
    };
  }
}

// wraps an object in a membrane to warn about deprecated property access
export default deprecateObjectProperties;